﻿using FluentNHibernate.Cfg;
using FluentNHibernate.Cfg.Db;
using NHibernate;
using NHibernate.Dialect;
using NHibernate.Driver;
using System;
using System.Linq.Expressions;

namespace NHibernateFrameworkSandbox
{
    class Program
    {
        static void Main(string[] args)
        {
            var start = DateTime.UtcNow;
            var sefact = CreateSessionFactory();
            using (var session = sefact.OpenSession())
            {
                var test1 = new Test { Id = 999, Value = "Hello" }; // note how Id is autogenerated and this Id will be overriden
                var test2 = new Test { Value = "world" };
                BenchMark("Connection opened -- Transaction start", start);
                using (var tx = session.BeginTransaction())
                {
                    session.Save(test1);
                    session.Save(test2);
                    BenchMark("2 tests created", start);
                    var tests = session.CreateCriteria<Test>().List<Test>();
                    foreach (var item in tests)
                    {
                        Console.WriteLine($"Id:{item.Id}, Value:{item.Value}");
                    }
                    BenchMark($"{tests.Count} tests loaded -- Transaction end", start);
                    tx.Commit();
                }
                test1.Value = "Bueños diaz";
                session.Update(test1);
                BenchMark($"Updated test value to '{test1.Value}' -- Transaction start", start);
                using(var tx2 = session.BeginTransaction()) {
                    test1 = session.Get<Test>(test1.Id);
                    BenchMark($"fetched test '{test1.Value}' with id {test1.Id}", start);
                    
                    session.Delete(test1);
                    BenchMark($"test with id {test1.Id} deleted -- Transaction end", start);

                    tx2.Commit();
                }
            }
            
            BenchMark("Press Enter to exit...", start);
            Console.ReadLine();
        }

        private static void BenchMark(string message, DateTime startTimeUtc)
        {
            Console.WriteLine($"{(DateTime.UtcNow - startTimeUtc).Milliseconds}ms elapsed: {message}");
        }

        private static ISessionFactory CreateSessionFactory()
        {
            var dataSource = "CI00014639";
            var initialCatalog = "CreateDBTest";
            var integratedSecurity = "True";

            return Fluently.Configure()
                .Database(MsSqlConfiguration.MsSql7.ConnectionString(
                                                        $"Server={dataSource};" +
                                                        $"Database={initialCatalog};" +
                                                        $"Integrated Security={integratedSecurity}"
                                                    )
                                                   .Driver<SqlClientDriver>()
                                                   .Dialect<MsSql7Dialect>()
                )
                .Mappings(m => 
                    m.FluentMappings.AddFromAssemblyOf<Program>()
                )
                .BuildSessionFactory();
        }
    }
}